#!/bin/zsh
. ./config.txt

K=128
BASEDIR=/windroot/chu/nile/AMR
DATA=$BASEDIR/data
LANGPAIR=amr_eng

WEIGHTS=k$K.$LANGPAIR.weights-98
NAME=$WEIGHTS.test-output.a

echo "nice -15 mpiexec -n $NUMCPUS $PYTHON $NILE_DIR/nile.py \ "
echo "  --f data/amr.stem.test \ "
echo "  --e data/eng.stem.test \ "
echo "  --etrees data/eng.stem.test.parse.bin \ "
echo "  --evcb data/test.e.vcb \ "
echo "  --fvcb data/test.f.vcb \ "
echo "  --pef model/GIZA++.m4.pef \ "
echo "  --pfe model/GIZA++.m4.pfe \ "
echo "  --a1 data/stem.giza.align.test \ "
echo "  --align \ "
echo "  --langpair $LANGPAIR \ "
echo "  --weights model/$WEIGHTS \ "
echo "  --out $NAME \ "
echo "  --k $K "

nice -15 mpiexec -n $NUMCPUS $PYTHON $NILE_DIR/nile.py \
  --f data/amr.stem.test \
  --e data/eng.stem.test \
  --etrees data/eng.stem.test.parse.bin \
  --evcb data/test.e.vcb \
  --fvcb data/test.f.vcb \
  --pef model/GIZA++.m4.pef \
  --pfe model/GIZA++.m4.pfe \
  --a1 data/stem.giza.align.test \
  --align \
  --langpair $LANGPAIR \
  --weights model/$WEIGHTS \
  --out $NAME \
  --k $K

# # Giza score: F-score: F-score: 0.86594, Precision: 0.91962, Recall: 0.81818
# echo "$NILE_DIR/Fmeasure.py data/stem.giza.align.test data/stem.gold.align.test"
# $NILE_DIR/Fmeasure.py data/stem.giza.align.test data/stem.gold.align.test

# Nile score: F-score: 0.88974, Precision: 0.94422, Recall: 0.84121
echo "$NILE_DIR/Fmeasure.py $NAME data/stem.gold.align.test"
$NILE_DIR/Fmeasure.py $NAME data/stem.gold.align.test
