. ./config.txt

ISI_SCRIPT_DIR=$ISI_aligner_DIR/scripts
DATA=./data/
AMR_SCRIPT_DIR=./script
LANGPAIR=amr_eng
K=128
WEIGHTS=k$K.$LANGPAIR.weights-98
NILE_ALIGNMENT=$WEIGHTS.test-output.a
GIZA_ALIGNMENT=data/stem.giza.align.test

# NAME=$GIZA_ALIGNMENT
NAME=$NILE_ALIGNMENT

# postprocess
# write back the alignments to the original positions
cat $NAME | python $ISI_SCRIPT_DIR/map-ibmpos-to-origpos_amr-as-f.py $DATA/eng.origpos.test > tmp.align.origpos.txt
# add eng alignment to amr_tuple
paste $DATA/amr.tuple.test tmp.align.origpos.txt | python $ISI_SCRIPT_DIR/get_aligned_tuple_amr-as-f_add-align.py > tmp.aligned_tuple.txt
# add back the amr stop words
paste $DATA/amr.test tmp.aligned_tuple.txt | python $ISI_SCRIPT_DIR/feat2tree_v9.py --align >tmp.align.ulf.txt 2>tmp.align.ulf.err 
# add word position to the eng sentences
cat $DATA/eng.sen.test | python $ISI_SCRIPT_DIR/add_word_pos.py > tmp.eng.viz.txt
# generate AMR_Aligned.keep
lines_number=$(wc -l < $DATA/amr.test)
count=0
while [ "$count" -ne $lines_number ]
do
  read eng_line
  echo '#' $eng_line
  count=$(( $count+1 ))
  awk NR==$count tmp.align.ulf.txt
  echo
done <tmp.eng.viz.txt > AMR_Aligned.keep

# generate Alignments.keep
g++ $ISI_SCRIPT_DIR/cpp/get_alignments.cpp
./a.out

# evaluation for new data
python $AMR_SCRIPT_DIR/eval.py Alignments.keep $GOLD_ISI_ALIGN_TEST
