. ./config.txt

# copy the following files from the ISI alignment directory to ./data, which has been done in this demo
# cp $ISI_aligner_DIR/data/all.txt.eng data/eng.sen.test
# cp $ISI_aligner_DIR/tmp.eng.tok.stemmed.txt data/eng.stem.test
# cp $ISI_aligner_DIR/tmp.eng.tok.origpos.txt data/eng.origpos.test
# cp $ISI_aligner_DIR/tmp.amr_linear.stemmed.txt data/amr.stem.test
# cp $ISI_aligner_DIR/data/all.txt.amr data/amr.test
# cp $ISI_aligner_DIR/tmp.align.real.txt data/stem.giza.align.test

# parse English sentences
echo "java -jar $berkeleyParser_DIR/berkeleyParser.jar -gr $berkeleyParser_DIR/eng_sm6.gr -binarize < data/eng.sen.test > data/eng.sen.test.parse.bin"
java -jar $berkeleyParser_DIR/berkeleyParser.jar -gr $berkeleyParser_DIR/eng_sm6.gr -binarize < data/eng.sen.test > data/eng.sen.test.parse.bin

# process obtained constituency trees by discarding the stop words, and replacing the leaf tokens with their stems
echo "perl ./script/conv_sen_parse_to_stem.pl -sen_parse data/eng.sen.test.parse.bin -stem data/eng.stem.test -origpos data/eng.origpos.test > data/eng.stem.test.parse.bin"
perl ./script/conv_sen_parse_to_stem.pl -sen_parse data/eng.sen.test.parse.bin -stem data/eng.stem.test -origpos data/eng.origpos.test > data/eng.stem.test.parse.bin

# create links for align.sh
# ln -s data/eng.stem.test data/test.e
# ln -s data/eng.stem.test.parse.bin data/test.e-parse
# ln -s data/amr.stem.test data/test.f
# ln -s data/stem.giza.align.test data/test.m4gdfa

echo "python $NILE_DIR/prepare-vocab.py < data/amr.stem.test > data/test.f.vcb"
echo "python $NILE_DIR/prepare-vocab.py < data/eng.stem.test > data/test.e.vcb"
python $NILE_DIR/prepare-vocab.py < data/amr.stem.test > data/test.f.vcb
python $NILE_DIR/prepare-vocab.py < data/eng.stem.test > data/test.e.vcb

# this is for evaluation, if you had gold alignments
# convert gold ISI alignment to giza format
echo "perl ./script/get_isi_alignment.pl < $GOLD_ISI_ALIGN_TEST > data/isi.align.test"
echo "g++ ./script/get_degree.cpp -o ./script/get_degree"
echo "./script/get_degree data/amr.test > data/amr.test.degree"
echo "perl ./script/isi_alignment_to_giza.pl -isi_alignment data/isi.align.test -amr_degree data/amr.test.degree \ "
echo "     -amr_linear data/amr.linear.test -eng_origpos data/eng.origpos.test > data/stem.gold.align.test"
perl ./script/get_isi_alignment.pl < $GOLD_ISI_ALIGN_TEST > data/isi.align.test
g++ ./script/get_degree.cpp -o ./script/get_degree
./script/get_degree data/amr.test > data/amr.test.degree
perl ./script/isi_alignment_to_giza.pl -isi_alignment data/isi.align.test -amr_degree data/amr.test.degree \
     -amr_linear data/amr.linear.test -eng_origpos data/eng.origpos.test > data/stem.gold.align.test

# ln -s data/stem.gold.align.test data/test.a
