#!/usr/bin/env perl

# convert sen parse results stems that also deleted stop words

use strict;
use utf8;
use Getopt::Long;

binmode STDIN, ":utf8";
binmode STDOUT, ":utf8";
binmode STDERR, ":utf8";

my %opt;
GetOptions(\%opt, 'sen_parse=s', 'stem=s', 'origpos=s', 'keep_stop=i');

open(IN_SEN_PARSE, "<:utf8", "$opt{sen_parse}") or die $!;
open(IN_STEM, "<:utf8", "$opt{stem}") or die $!;
open(IN_ORIGPOS, "<:utf8", "$opt{origpos}") or die $!;
while(my $sen_parse = <IN_SEN_PARSE>) {
    my $stem = <IN_STEM>;
    my $origpos = <IN_ORIGPOS>;
    chomp($sen_parse);
    chomp($stem);
    chomp($origpos);
    my @phrase_array = split(/\) /, $sen_parse);
    my @stem_array = split(/ /, $stem);
    my @pos_array = split(/ /, $origpos);
    my %pos_stem_hash;
    for(my $pos = 0; $pos < scalar(@pos_array); $pos++) {
	$pos_stem_hash{$pos_array[$pos]} = $stem_array[$pos];
    }
    # print STDERR "===============================\n";
    my $stem_parse;
    for(my $pos = 0; $pos < scalar(@phrase_array)-1; $pos++) {
	if($pos_stem_hash{$pos} || $pos_stem_hash{$pos} eq '0') {
	    # using word
	    # $stem_parse .= "$phrase_array[$pos]\) ";
	    my @closing_bracket_array = $phrase_array[$pos] =~ /\)/g;
	    $phrase_array[$pos] =~ s/\)//g;
	    if($phrase_array[$pos] =~ /(.*) (.*)/) {
	    	# print STDERR "$1\###$2\###\n";
	    	# print STDERR "$1\###$pos_stem_hash{$pos}\###\n";
		$stem_parse .= "$1 $pos_stem_hash{$pos}";
	    }
	    foreach my $closing_bracket (@closing_bracket_array) {
	    	# print STDERR "$closing_bracket";
		$stem_parse .= "$closing_bracket";
	    }
	    $stem_parse .= "\) ";
	    # print STDERR "\n";
	}
	# for stop words
	# delete $num+2 tokens, which $num is the # of following closing brackets
	else {
	    if($opt{keep_stop} == 1) {
		$stem_parse .= "$phrase_array[$pos]\) ";
	    } else {
		# $phrase_array[$pos] =~ s/SYM \)/SYM /g;
		# $phrase_array[$pos] =~ s/ \($/ /g;
		# print STDERR "$phrase_array[$pos]\n";
		my @closing_bracket_array = $phrase_array[$pos] =~ /\)/g;
		my $num = scalar(@closing_bracket_array);
		# print STDERR "num: $num\n";
		my @token_array = split(/\(/, $phrase_array[$pos]);
		# foreach my $token (@token_array) {
		#     print STDERR "\#$token\#\n";
		# }
		# start from id=1, because the first element is empty in @token_array
		for(my $id = 1; $id < scalar(@token_array)-$num-1; $id++) {
		    $stem_parse .= "\($token_array[$id]";
		}
		if((scalar(@token_array)-$num-1) <= 0) {
		    # print STDERR "$phrase_array[$pos]\t";
		    # print STDERR scalar(@token_array), "\t", $num, "\t$token_array[1]\t", $judge, "\n";

		    $stem_parse =~ s/ $//g;
		    my $judge = (scalar(@token_array)-$num-1)*(-1);
		    for(my $i = 0; $i <= $judge; $i++) {
			$stem_parse .= "\)";
			# print STDERR "\#$i\#\n";
		    }
		    $stem_parse .= " ";
		}
	    }
	}
    }
    $stem_parse =~ s/ $//g;
    $stem_parse =~ s/\(\S+?\)//g;
    $stem_parse =~ s/\(\S+ ?\)//g;
    $stem_parse =~ s/ +/ /g;
    $stem_parse =~ s/\) \)/\)\)/g;
    $stem_parse .= " \)";
    print "$stem_parse\n";
}
close IN_SEN_PARSE;
close IN_STEM;
close IN_ORIGPOS;
