#!/usr/bin/env python
# -*- coding: utf-8 -*-

import re,sys,os

def eval_ISI_align(pred_file, gold_file):

    gold_A = []
    test_A =[]

    gold_A_no_roles = []
    test_A_no_roles = []
    align_pat = re.compile("(# ::alignments\s)(.+)(\n)")

    with open(gold_file) as gold:
        for line in gold:
            if align_pat.match(line):
                A = []
                A_no_roles = []
                alignments = align_pat.match(line).group(2)
                a_pairs = alignments.split()
                for pair in a_pairs:
                    a = pair.split("-")
                    if a[1][-1] != "r":
                        A_no_roles.append(tuple(a))
                    A.append(tuple(a))
                gold_A.append(A)
                gold_A_no_roles.append(A_no_roles)

    with open(pred_file) as test:
        for line in test:
            A = []
            A_no_roles = []
            a_pairs = line.strip().split()
            for pair in a_pairs:
                a = pair.split("-")
                if a[1][-1] != "r":
                    A_no_roles.append(tuple(a))
                A.append(tuple(a))
            test_A.append(A)
            test_A_no_roles.append(A_no_roles)

    t_count = len(test_A)
    g_count = len(gold_A)

    assert g_count == t_count, \
        "Total counts: golden - %d, predicted -%d. Mismatch!" %(g_count, t_count)

    len_g = len_p = len_i = nr_len_g = nr_len_p = nr_len_i = 0.0

    for idx, test_al in enumerate(test_A):
        golden_alignments = set(gold_A[idx])
        predicted_alignments = set(test_al)

        len_g += len(golden_alignments)
        len_p += len(predicted_alignments)
        len_i += len(golden_alignments & predicted_alignments)

        # counting ignoring role tags

        nr_golden_alignments = set(gold_A_no_roles[idx])
        nr_predicted_alignments = set(test_A_no_roles[idx])

        nr_len_g += len(nr_golden_alignments)
        nr_len_p += len(nr_predicted_alignments)
        nr_len_i += len(nr_golden_alignments & nr_predicted_alignments)

    pr = len_i / len_p if len_p > 0 else 0
    r = len_i / len_g if len_g > 0 else 0
    f = 2 * (pr * r) / (pr + r)

    nr_pr = nr_len_i / nr_len_p if nr_len_p > 0 else 0
    nr_r = nr_len_i / nr_len_g if nr_len_g > 0 else 0
    nr_f = 2 * (nr_pr * nr_r) / (nr_pr + nr_r)

    r_pr = (len_i - nr_len_i) / (len_p - nr_len_p) if (len_p - nr_len_p) > 0 else 0
    r_r = (len_i - nr_len_i) / (len_g - nr_len_g) if (len_g - nr_len_g) > 0 else 0
    r_f = 2 * (r_pr * r_r) / (r_pr + r_r)

    print "Stats w/ role tokens:\nPrecision: %f\nRecall: %f\nF-score: %f\n\n"\
        %(pr,r,f)
    print "Stats w/o role tokens:\nPrecision: %f\nRecall: %f\nF-score: %f\n\n"\
        %(nr_pr, nr_r, nr_f)
    print "Stats role tokens:\nPrecision: %f\nRecall: %f\nF-score: %f\n\n"\
        %(r_pr, r_r, r_f)

eval_ISI_align(sys.argv[1], sys.argv[2])
