#!/usr/bin/env perl

use strict;
use utf8;
use Getopt::Long;

binmode STDIN, ":utf8";
binmode STDOUT, ":utf8";
binmode STDERR, ":utf8";

my %opt;
GetOptions(\%opt, 'origpos=s');

open(IN_ORIGPOS, "<:utf8", "$opt{origpos}") or die $!;
while(my $origpos_str= <IN_ORIGPOS>) {
    my $align_str = <STDIN>;
    chomp($origpos_str);
    chomp($align_str);
    my %pos_hash;
    my @pos_array = split(/ /, $origpos_str);
    foreach my $pos (@pos_array) {
	my ($stem_pos, $origpos) = split(/\-/, $pos);
	$pos_hash{$origpos} = $stem_pos;
    }

    my @align_array = split(/ /, $align_str);
    my $post_align;
    foreach my $align (@align_array) {
	my ($amr_pos, $eng_pos) = split(/\-/, $align);
	if($pos_hash{$amr_pos}) {
	    $post_align .= "$pos_hash{$amr_pos}\-$eng_pos ";
	} else {
	    $post_align .= "$amr_pos\-$eng_pos ";
	}
    }
    $post_align =~ s/ \Z//g;
    print "$post_align\n";
}
close IN_ORIGPOS;
